config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do
  resources :projects do
    member do
      get :sponsors
    end
  end
  namespace :admin do
      resources :users
      resources :announcements
      resources :notifications
      resources :services

      root to: "users#index"
    end
  get '/privacy', to: 'home#privacy'
  get '/get_started', to: 'home#get_started'
  get '/creators', to: 'home#creators'
  get '/sponsors', to: 'home#sponsors'
  resources :notifications, only: [:index]
  resources :announcements, only: [:index]
  authenticate :user, lambda { |u| u.admin? } do
    mount Sidekiq::Web => '/sidekiq'
  end

  devise_for :users, controllers: { omniauth_callbacks: "users/omniauth_callbacks" }
  root to: 'home#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :user
  acts_as_tree

  require 'iota'
  after_create :create_address

  extend FriendlyId
  friendly_id :title, use: [:slugged, :finders, :history]

  # VALIDATIONS
  validates :title, length: { minimum: 1, maximum: 100 }

  private

  def create_address
    # Create client directly with provider
    client = IOTA::Client.new(provider: 'https://iota.nodes24.com')

    # now you can start using all of the functions
    #status, data = client.api.getNodeInfo

    ## create and save seed
    self.seed = (1..81).map{'ABCDEFGHIJKLMNOPQRSTUVWXYZ9'[SecureRandom.random_number(27)]}.join('')

    ## create and save latest address
    account = IOTA::Models::Account.new(client, self.seed)
    account.getAccountDetails({})

    self.address = account.latestAddress
    self.save!

  end

end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy, :sponsors]

  layout 'project', only: [:show, :sponsors]

  # GET /projects
  # GET /projects.json
  def index
    @projects = Project.all
  end

  # GET /projects/1
  # GET /projects/1.json
  def show
  end

  # GET /projects/new
  def new
    @project = Project.new
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects
  # POST /projects.json
  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: 'Project was successfully created.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: 'Project was successfully updated.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: 'Project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # GET /projects/1/sponsors
  # GET /projects/1/sponsors.json
  def sponsors
  end


  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.require(:project).permit(:title, :vision, :descripton, :user_id, :public)
    end
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/projects/_form.html.erb
<%= form_with(model: project, local: true) do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
      <% project.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :title %>
    <%= form.text_field :title, class: 'form-control', placeholder: 'My awesome project' %>
  </div>

  <div class="form-group">
    <%= form.label :vision %>
    <%= form.text_field :vision, class: 'form-control', placeholder: 'Briefly describe your project' %>
  </div>

  <div class="form-group">
    <%= form.label :description %>
    <%= form.text_field :description, class: 'form-control', placeholder: 'Enter a detailed description of your project' %>
  </div>

  <div class="form-group">
    <%= form.label :user_id %>
    <%= form.text_field :user_id, class: 'form-control' %>
  </div>

  <div class="form-check m-b-20">
    <label class="form-check-label">
      <%= form.check_box :public, class: "form-check-input" %>
      Public
    </label>
  </div>

  <div class="actions m-t-30 m-b-0">
    <% if project.persisted? %>
    <%= link_to project, method: :delete, class: "btn btn-danger btn-icon float-left", data: { confirm: 'Are you sure?' } do %>
      <%= image_tag "icons/bin.svg" %>
    <% end %>
    <% end %>

    <%= form.submit class: 'btn btn-primary m-l-10 float-right' %>

    <% if project.persisted? %>
      <%= link_to "Cancel", project, class: "btn btn-light float-right" %>
    <% else %>
      <%= link_to "Cancel", projects_path, class: "btn btn-light float-right" %>
    <% end %>
  </div>
<% end %>

app/views/projects/_navbar.html.erb
<nav class="navbar navbar-expand-lg">
  <div class="meta-nav">
    <ul>
      <% @project.children.each do |child_project| %>
        <li><a href="<%= child_project.url %>"><%= child_project.title %></a></li>
      <% end %>
    </ul>
  </div>
  <a class="navbar-brand" href="<%= root_path %>">
    <%= image_tag("logo.svg") %>
  </a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavDropdown" aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
    <div class="navbar-toggler-wrapper">
      <span class="line line__top"></span>
      <span class="line line__center"></span>
      <span class="line line__bottom"></span>
    </div>
  </button>
  <div class="collapse navbar-collapse" id="navbarNavDropdown">
    <ul class="navbar-nav">
      <li class="nav-item <%= "active" if request.path == '/announcements' %>""><%= link_to "Creators", announcements_path, class: "nav-link #{unread_announcements(current_user)}" %></li>
      <li class="nav-item <%= "active" if request.path == sponsors_project_path %>""><%= link_to "Sponsors", sponsors_project_path, class: "nav-link #{unread_announcements(current_user)}" %></li>
      <li class="nav-item <%= "active" if request.path == '/announcements' %>""><%= link_to "Roadmap", announcements_path, class: "nav-link #{unread_announcements(current_user)}" %></li>
      <% if user_signed_in? %>

      <li class="nav-item icon">
        <%= link_to notifications_path, class: "nav-link" do %>
          <%= image_tag "icons/notification.svg" %>
        <% end %>
      </li>

      <li class="nav-item dropdown">
        <%= link_to root_path, id: "navbar-dropdown", class: "nav-link dropdown-toggle", data: { toggle: "dropdown" }, aria: { haspopup: true, expanded: false } do %>
          <%= image_tag gravatar_image_url(current_user.email, size: 40), height: 30, width: 30, class: "rounded" %>
        <% end %>
        <div class="dropdown-menu dropdown-menu-left" aria-labelledby="navbar-dropdown">
          <% if current_user.admin? %>
            <%= link_to "Admin Area", admin_root_path, class: "dropdown-item" %>
            <div class="dropdown-divider"></div>
          <% end %>
          <%= link_to "Settings", edit_user_registration_path, class: "dropdown-item" %>
          <div class="dropdown-divider"></div>
          <%= link_to "Logout", destroy_user_session_path, method: :delete, class: "dropdown-item" %>
        </div>
      </li>

      <% else %>
        <li class="nav-item button"><%= link_to "Sign Up", new_user_registration_path, class: "btn btn-primary", style: "color: #fff" %></li>
        <li class="nav-item button"><%= link_to "Log in", new_user_session_path, class: "btn btn-primary", style: "color: #fff" %></li>
      <% end %>
    </ul>
  </div>
</nav>

app/views/projects/edit.html.erb
<div class="section page-title bg-primary">
  <div class="container">
    <div class="row">
      <div class="col-md">
        <h1 class="text-center"><h1>Edit Project</h1></h1>
      </div>
    </div>
  </div>
</div>

<div class="container">
  <div class="row">
    <div class="col-lg-8 ml-auto mr-auto breadcrumb-wrapper">
      <div class="breadcrumb-container">
        <%= link_to root_path do %>Back to Home<% end %>
      </div>
      <div class="box">
        <%= render 'form', project: @project %>
      </div>
    </div>
  </div>
</div>

app/views/projects/index.html.erb
<div class="section page-title bg-primary">
  <div class="container">
    <div class="row">
      <div class="col-md">
        <h1 class="text-center m-b-20">Projects</h1>
        <%= link_to new_project_path, class: 'btn btn-dark' do %>
          Add New Project
        <% end %>
      </div>
    </div>
  </div>
</div>

<div class="container">
  <div class="row">
    <div class="col-lg ml-auto mr-auto breadcrumb-wrapper">
      <div class="breadcrumb-container">
        <%= link_to root_path do %>Back to Home<% end %>
      </div>
      <div class="table-responsive">
        <table class="table table-striped table-bordered table-hover">
          <thead>
            <tr>
              <th>Title</th>
              <th>Vision</th>
              <th>Description</th>
              <th>User</th>
              <th>Public</th>
              <th></th>
            </tr>
          </thead>

          <tbody>
            <% @projects.each do |project| %>
              <%= content_tag :tr, id: dom_id(project), class: dom_class(project) do %>
                  <td><%= project.title %></td>
                  <td><%= project.vision %></td>
                  <td><%= project.description %></td>
                  <td><%= project.user %></td>
                  <td><%= project.public %></td>
                  <td><%= link_to 'Show', project %></td>
              <% end %>
            <% end %>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>

app/views/projects/new.html.erb
<div class="section page-title bg-primary">
  <div class="container">
    <div class="row">
      <div class="col-md">
        <h1 class="text-center">New project</h1>
      </div>
    </div>
  </div>
</div>

<div class="container">
  <div class="row">
    <div class="col-lg-8 ml-auto mr-auto breadcrumb-wrapper">
      <div class="breadcrumb-container">
        <%= link_to root_path do %>Back to Home<% end %>
      </div>
      <div class="box">
        <%= render 'form', project: @project %>
      </div>
    </div>
  </div>
</div>

app/views/projects/show.html.erb
<%= render "projects/navbar" %>

<div class="section hero bg-primary">
  <div class="container">
    <div class="row">
      <div class="col-md-6">
        <h1 class="title"><%= @project.title %></h1>
        <h5 class="m-b-20"><%= @project.vision %></h5>
        <p><%= @project.description %></p>
        <a href="/get_started" class="btn btn-dark btn-lg m-r-30 m-b-20">Get started</a>
      </div>
    </div>
  </div>
  <div class="illustration"></div>
  <div class="illustration-mobile"></div>
</div>
<div class="section p-t-100 p-b-100">
  <div class="container">
    <div class="row">
      <div class="col-lg">
        <h1 class="text-center">Child projects</h1>
        <hr>
      </div>
    </div>
    <div class="row">
      <div class="col-lg">
        <div class="box-grid">
          <% @project.children.each do |child_project| %>
          <a href="<%= child_project.url %>" target="_blank" class="box">
            <h6 style="opacity: .5;">Owner: <%= @project.user.username %></h6>
            <h4 class="m-b-5"><%= child_project.title %></h4>
            <p class="m-b-0"><%= child_project.description %></p>
          </a>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</div>
<div class="section bg-primary p-t-100 p-b-100">
  <div class="container">
    <div class="row">
      <div class="col-lg">
        <h1 class="text-center">Creators</h1>
        <hr>
      </div>
    </div>
    <div class="row">
      <div class="col-lg">
        <div class="box-grid">
          <% @project.children.each do |child_project| %>
          <a href="<%= child_project.url %>" target="_blank" class="box">
            <div class="box-header">
              <div class="creator">
                <div class="user-avatar">
                  <%= image_tag "icons/user.svg" %>
                </div>
                <div class="user-title">
                  <h5>Creator name</h5>
                  <span>Job title</span>
                </div>
              </div>
            </div>
            <div class="box-body">
              <p class="box-text">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>
            </div>
          </a>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/projects/sponsors.html.erb
<div class="section page-title bg-primary m-b-0">
  <div class="container">
    <div class="row">
      <div class="col-md">
        <h1 class="text-center m-b-20">Sponsors</h1>
        <p class="mr-auto ml-auto" style="max-width: 500px;">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>
        <a href="#" class="btn btn-dark">Become a sponsor</a>
        <%= react_component("Balance", { address: @project.address }) %>
        <div class="btn btn-primary buttonCopyAddressk" data-toggle="tooltip" data-placement="bottom" title="<%= @project.address %>"  data-address="<%= @project.address %>">
          <%= @project.address.truncate(9, omission: "...#{@project.address.last(3)}") %>
        </div>
      </div>
    </div>
  </div>
</div>

<div class="section p-t-50 p-b-100" style="margin-bottom: -100px;">
  <div class="container">
    <div class="row">
      <div class="col-lg">
        <div class="sponsors-header sponsors-header__diamond">
          <h5>Diamond</h5>
        </div>
        <div class="box-grid">
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
        </div>
        <div class="sponsors-header sponsors-header__platin">
          <h5>Platin</h5>
        </div>
        <div class="box-grid">
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
        </div>
        <div class="sponsors-header sponsors-header__gold">
          <h5>Gold</h5>
        </div>
        <div class="box-grid">
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
        </div>
        <div class="sponsors-header sponsors-header__silver">
          <h5>Silver</h5>
        </div>
        <div class="box-grid">
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
        </div>
        <div class="sponsors-header sponsors-header__bronze">
          <h5>Bronze</h5>
        </div>
        <div class="box-grid">
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
          <div class="box  box-center">
            <div class="box-body">
              <%= image_tag "icons/image-dark.svg", class: 'logo mr-auto ml-auto m-b-15', style: 'opacity: .25;' %>
              <h5>Brandname</h5>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<script type="text/javascript">
  $(".buttonCopyAddressk").on("click", function(event) {
    var address = $(this).data('address');
    copyToClipboard(address)
    successAnimation(event.target)
    console.log("jiji");
  });

</script>